/* hyuk kim hyuk.kim@xilinx.com,   dbase.hyuk.kim@gmail.com */
#ifndef XNPI_H
#define XNPI_H

#ifdef __cplusplus
extern "C" {
#endif


/* NPI CMD */
#define NPI_CMD_WR 						0x66	
#define NPI_CMD_RD 						0x55	
#define NPI_CMD_RST 					0x9a

/* NPI STATUS */
#define NPI_ST_INIT_DONE 				0x80000000
#define NPI_ST_WR_FIFO_FULL 			0x40000000
#define NPI_ST_RD_FIFO_FULL 			0x20000000
#define NPI_ST_WR_FIFO_EMPTY			0x10000000
#define NPI_ST_RD_FIFO_EMPTY			0x08000000
#define NPI_ST_WR_READY					0x04000000
#define NPI_ST_RD_READY					0x02000000

/* NPI REGISTER OFFSET */
#define NPI_REG_STATUS					0x00000000
#define NPI_REG_BURST					0x00000004
#define NPI_REG_ADD_CNT					0x00000008
#define NPI_REG_SM_STATUS				0x0000000c

/* NPI STATE MACHINE */
#define	NPI_SM_FIFO_RST3CLK				
#define	NPI_SM_IDLE 					0x00 
#define	NPI_SM_MPMC_RD_FLUSH_RST		0x01 
#define	NPI_SM_MPMC_RD_FLUSH_RST_WAIT	0x02
#define	NPI_SM_MPMC_WR_FLUSH_RST		0x03 
#define	NPI_SM_MPMC_WR_FLUSH_RST_WAIT	0x04	 
#define	NPI_SM_WAIT_COMMAND				0x05 
#define	NPI_SM_WR_WAIT_RDY				0x06 
#define	NPI_SM_WR_WAIT_FULL				0x07 
#define	NPI_SM_WR_DATA_PUSH				0x08 
#define	NPI_SM_WR_ADD_REQ_ACK			0x09 
#define	NPI_SM_WR_WAIT_EMPTY_HIGH		0x0a
#define	NPI_SM_RD_WAIT_RDY				0x0b 
#define	NPI_SM_RD_ADD_REQ				0x0c 
#define	NPI_SM_RD_POP_DATA				0x0d 
#define	NPI_SM_RD_NEXT					0x0e 
#define	NPI_SM_RD_FINISH				0x0f 

#ifdef __cplusplus
}
#endif

#endif /* end of protection macro */
